# Autogenerated wrapper script for ReadStat_jll for x86_64-apple-darwin14
export readstat, libreadstat

using Libiconv_jll
using Zlib_jll
## Global variables
PATH = ""
LIBPATH = ""
LIBPATH_env = "DYLD_FALLBACK_LIBRARY_PATH"

# Relative path to `readstat`
const readstat_splitpath = ["bin", "readstat"]

# This will be filled out by __init__() for all products, as it must be done at runtime
readstat_path = ""

# readstat-specific global declaration
function readstat(f::Function; adjust_PATH::Bool = true, adjust_LIBPATH::Bool = true)
    global PATH, LIBPATH
    env_mapping = Dict{String,String}()
    if adjust_PATH
        if !isempty(get(ENV, "PATH", ""))
            env_mapping["PATH"] = string(PATH, ':', ENV["PATH"])
        else
            env_mapping["PATH"] = PATH
        end
    end
    if adjust_LIBPATH
        if !isempty(get(ENV, LIBPATH_env, ""))
            env_mapping[LIBPATH_env] = string(LIBPATH, ':', ENV[LIBPATH_env])
        else
            env_mapping[LIBPATH_env] = LIBPATH
        end
    end
    withenv(env_mapping...) do
        f(readstat_path)
    end
end


# Relative path to `libreadstat`
const libreadstat_splitpath = ["lib", "libreadstat.1.dylib"]

# This will be filled out by __init__() for all products, as it must be done at runtime
libreadstat_path = ""

# libreadstat-specific global declaration
# This will be filled out by __init__()
libreadstat_handle = C_NULL

# This must be `const` so that we can use it with `ccall()`
const libreadstat = "@rpath/libreadstat.1.dylib"


"""
Open all libraries
"""
function __init__()
    global artifact_dir = abspath(artifact"ReadStat")

    # Initialize PATH and LIBPATH environment variable listings
    global PATH_list, LIBPATH_list
    # We first need to add to LIBPATH_list the libraries provided by Julia
    append!(LIBPATH_list, [joinpath(Sys.BINDIR, Base.LIBDIR, "julia"), joinpath(Sys.BINDIR, Base.LIBDIR)])
    # From the list of our dependencies, generate a tuple of all the PATH and LIBPATH lists,
    # then append them to our own.
    foreach(p -> append!(PATH_list, p), (Libiconv_jll.PATH_list, Zlib_jll.PATH_list,))
    foreach(p -> append!(LIBPATH_list, p), (Libiconv_jll.LIBPATH_list, Zlib_jll.LIBPATH_list,))

    global readstat_path = normpath(joinpath(artifact_dir, readstat_splitpath...))

    push!(PATH_list, dirname(readstat_path))
    global libreadstat_path = normpath(joinpath(artifact_dir, libreadstat_splitpath...))

    # Manually `dlopen()` this right now so that future invocations
    # of `ccall` with its `SONAME` will find this path immediately.
    global libreadstat_handle = dlopen(libreadstat_path)
    push!(LIBPATH_list, dirname(libreadstat_path))

    # Filter out duplicate and empty entries in our PATH and LIBPATH entries
    filter!(!isempty, unique!(PATH_list))
    filter!(!isempty, unique!(LIBPATH_list))
    global PATH = join(PATH_list, ':')
    global LIBPATH = join(LIBPATH_list, ':')

    # Add each element of LIBPATH to our DL_LOAD_PATH (necessary on platforms
    # that don't honor our "already opened" trick)
    #for lp in LIBPATH_list
    #    push!(DL_LOAD_PATH, lp)
    #end
end  # __init__()

